import java.text.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import java.math.*;

public class Bench
{

	public static void main (String argv[]) throws SQLException
	{
		Connection monet, mysql;
		long start, end, mon_time, mysql_time;
		String[] query = new String[5];
		int i, j;
		FileWriter out = null;




		query[0] = "SELECT EntryId, URL " +
				   "	FROM Entry " +
				   "	WHERE url = 'http://www.php.net/index.php'";


		query[1] = "SELECT URL " +
				   "	FROM Entry " +
				   "	WHERE LOWER(Domain) LIKE '%math%'  OR LOWER(Path) LIKE '%math%'" +
				   "		OR LOWER(Page) LIKE '%math%' ";

		query[2] = "SELECT COUNT(*) FROM Entry UNION SELECT COUNT(*) FROM Link";


		query[3] = "SELECT E.Domain, COUNT(L.Entry) AS Number_of_links " +
				   "	FROM Entry E, Link L " +
				   "	WHERE L.Entry = EntryId " +
				   " 	GROUP BY E.Domain " +
				   "	HAVING E.Domain = 'http://www.php.net'";



		query[4] = "SELECT U.URL, COUNT(LinksTo) As num_linked_from " +
				   "	FROM Entry U, Link L " +
				   "	WHERE EntryId = LinksTo AND (LOWER(U.Domain) LIKE '%math%' OR LOWER(U.Path) LIKE '%math%' " +
				   "	OR LOWER(U.Page) LIKE '%math%') " +
				   "	GROUP BY U.URL " +
				   "	ORDER BY num_linked_from DESC, U.url " +
				   "	LIMIT 10;";


		try
		{
			out = new FileWriter("result2.txt");

			Class.forName("nl.cwi.monetdb.jdbc.MonetDriver");
			monet = DriverManager.getConnection(
				"jdbc:monetdb://localhost/ggle", "ggle", "gsa#1");

			Class.forName("com.mysql.jdbc.Driver");
			mysql = DriverManager.getConnection(
				"jdbc:mysql://localhost/ggle?user=ggle&password=gsa#1");

			Statement mon_stmt = monet.createStatement();
			Statement mysql_stmt = mysql.createStatement();


			out.write("RESPONSE TIME IN MILLISECONDS\n\n");
			out.write("\t\tMonetDB\t\tMySQL\n");
			out.write("-------------------------------------------\n");


			// --------------------------------------- loop through all queries
			for( i=0; i < 5; i++)
			{
				mon_time = 0;
				mysql_time = 0;
				// -------------------------------------- average over 20 times
				for( j=0; j < 51; j++)
				{

					start = System.currentTimeMillis();
					mon_stmt.execute(query[i]);
					end = System.currentTimeMillis();

					if( j != 0 )
						mon_time += (end - start);

					start = System.currentTimeMillis();
					mysql_stmt.execute(query[i]);
					end = System.currentTimeMillis();

					if( j != 0 )
						mysql_time += (end - start);
				}
				mon_time = Math.round(mon_time/(j-1));
				mysql_time = Math.round(mysql_time/(j-1));

				out.write("Query " + (i+1) + "\t|\t" + mon_time + "\t\t" + mysql_time + "\n");
			}

			out.write("\n\n\nRESPONSE TIME PER TRANSACTION OVER 20 RUNS\n\n");
			out.write("\t\tMonetDB\t\tMySQL\n");
			out.write("-------------------------------------------\n");

			// -------------------------------------------------- loop 20 runs
			for( i=0; i < 50; i++)
			{
				mon_time = 0;
				mysql_time = 0;
				// -------------------------------------- loop over all queries
				start = System.currentTimeMillis();
				for( j=0; j < 5; j++)
				{
					mon_stmt.execute(query[j]);
				}
				end = System.currentTimeMillis();

				mon_time = end - start;

				for( j=0; j < 5; j++)
				{
					mysql_stmt.execute(query[j]);
				}
				end = System.currentTimeMillis();

				mysql_time = end - start;

				out.write("Run " + (i+1) + "\t|\t"+mon_time+"\t\t"+mysql_time+"\n");
			}



			out.close();
			monet.close();
			mysql.close();

		}
		catch(Exception e)
		{

			try{ out.close(); }catch(Exception ex){System.out.println(ex); };
			System.out.println(e);
		}
	}
}
