import java.text.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class WebCrawler2
{
	public static final int LIMIT = 2000;
	public static final String DISALLOW = "Disallow:";


	// initialize search data structures
	LinkedList toSearch = new LinkedList();
	LinkedList searched = new LinkedList();
	static Hashtable pageDatabase = new Hashtable();

	BufferedWriter xmlOut;


	public void init()
	{
		System.out.println("initializing ..");
		try
		{
			xmlOut = new BufferedWriter( new FileWriter("test.xml"));
			xmlOut.write("<ggle>\n");
		}
		catch( IOException e )
		{
			System.out.println("Couldn't open file: " + e);
		}
	}


	public void cleanup()
	{
		if( xmlOut != null )
		{
			try
			{
				xmlOut.flush();
				xmlOut.close();
			}
			catch( IOException e)
			{
				System.out.println(e);
			}
			xmlOut = null;
		}
	}

	/*---------------------------------------------------------------------- crawl()
	|
	\-----------------------------------------------------------------------------*/
	public void crawl(String startURL)
	{


		String strTargetType = "text/html";
		String strURL;
		int found = 0;
		URL url;

		toSearch.addLast(startURL);
		//toSearch.addLast("http://www.spiegel.de/");
		toSearch.addLast("http://www.cs.unibo.it/~rvalenti/");
		toSearch.addLast("http://www.cs.unibo.it/");
		toSearch.addLast("http://www.bbc.uk.com/");
		toSearch.addLast("http://www.html.it/");
		toSearch.addLast("http://www.spiegel.de/");
		toSearch.addLast("http://pages.yahoo.com/nhp/computers___internet/programming_languages");

		while ((toSearch.size() > 0) && (found < LIMIT))
		{
			// get the first element from the to be searched list
			strURL = (String) toSearch.removeFirst();

			System.out.println("searching " + strURL+"       "+found+" saved until now");


			try
			{
				url = new URL(strURL);
			}
			catch (MalformedURLException e)
			{
				System.out.println("ERROR: invalid URL " + strURL);
				continue;
			}




			// can only search http: protocol URLs
			if (url.getProtocol().compareTo("http") != 0)
				continue;
			if ( alreadyVisited(strURL) )
            	continue;
			markAsVisited(strURL);

			//--------------------------------------------------read url content
			try
			{
				// try opening the URL
				URLConnection urlConnection = url.openConnection();

				urlConnection.setAllowUserInteraction(false);

				InputStream urlStream = url.openStream();

				//get url info
				String type = urlConnection.guessContentTypeFromStream(urlStream);
				 long dom =(urlConnection.getLastModified());
				long doc = (urlConnection.getDate());
				DateFormat form = new SimpleDateFormat("dd-MM-yyyy");
				int size = urlConnection.getContentLength();

				if (type == null)
					continue;
				if (type.compareTo("text/html") != 0)
					continue;
				urlStream.close();

				//-----------------------------------------write entry to file
				found++;

				try
				{
					xmlOut.write("<entry url=\"" + strURL + "\" doc=\"" +
							  doc + "\" dom=\"" +
							  dom +
							  "\" size=\"" + size + "\">\n");
				}
				catch(IOException e)
				{
					System.out.println("Error when writing: " + strURL);
				}

			}
			catch( IOException e )
			{
				System.out.println("IO Exception!!!: " + e);
				continue;
			}

			String webPage= getPage(url);
			// search the input stream for links
			// first, read in the entire URL

			Vector bag=extractHyperTextLinks(webPage,strURL);
			System.out.println("Found "+bag.size()+" links in page "+ url);
			for (int i=1;i<bag.size();i++)
			{
				String strLink=(String) bag.elementAt(i);
				toSearch.addLast(strLink);
				System.out.println("found link: " + strLink);
				try
				{
					xmlOut.write("	<link url=\"" + strLink + "\"/>\n");
				}
				catch(IOException e)
				{
					System.out.println("Error when writing: " + strURL);
				}

			}

		    //END LINKS
		    try
			{
				xmlOut.write("</entry>\n");
			}
			catch(IOException e)
			{
				System.out.println("Error when writing: " + e);
			}
		}//END SEARCH

		try
		{
			xmlOut.write("</ggle>");
		}
		catch(IOException e)
		{
			System.out.println("Error when writing: " + e);
		}

		this.cleanup();
	}//END FUNCITON

	/*----------------------------------------------------------------------- main()
			|
	\-----------------------------------------------------------------------------*/



protected Vector extractHyperTextLinks(String page,String url) {

int lastPosition = 0;           // position of "http:" substring in page
int endOfURL;                   // pos of end of http://........
int save=0;
int position=0;
String link;                    // the link we're after
Vector bagOfLinks = new Vector();  // a bag to accumulate interesting links
String domain;
//extract domain
while (lastPosition!= -1)
{save=lastPosition;
lastPosition =url.indexOf("/", lastPosition+1);
}
domain = url.substring(0, save+1);
lastPosition=0;
String lowerCaseContent = page.toLowerCase();
int index = 0;

				//---------------------------------------------- find all links
				while ( (index = lowerCaseContent.indexOf("<a", index)) != -1 )
				{

		    		if ((lowerCaseContent.indexOf("href", index)) == -1)
		    		{
						index++;
						continue;
					}
					else
						index = lowerCaseContent.indexOf("href", index);

					if ((lowerCaseContent.indexOf("=", index)) == -1)
					{
						index++;
						continue;
					}
					else
						index = lowerCaseContent.indexOf("=", index);

					index++;

					String remaining = lowerCaseContent.substring(index);


					StringTokenizer st
							      = new StringTokenizer(remaining, "#\t\n\r\">");
		    		link = st.nextToken();
		    		 // Trasform in absolute url
												if (link.indexOf("http") == -1) {
													link = domain.concat(link);
												}

					bagOfLinks.addElement(link);
				}

/*  int index = 0; // position in page
  int iEndAngle, ihref, iURL, iCloseQuote, iHatchMark, iEnd;
  String lcPage = page.toLowerCase(); // Page in lower case
  while ((index = lcPage.indexOf("<a",index)) != -1) {
    iEndAngle = lcPage.indexOf(">",index);
    ihref = lcPage.indexOf("href",index);
    if (ihref != -1) {
      iURL = lcPage.indexOf("\"", ihref) + 1;
      if ((iURL != -1) && (iEndAngle != -1) && (iURL < iEndAngle))
        { iCloseQuote = lcPage.indexOf("\"",iURL);
          iHatchMark = lcPage.indexOf("#", iURL);
          if ((iCloseQuote != -1) && (iCloseQuote < iEndAngle)) {
            iEnd = iCloseQuote;
            if ((iHatchMark != -1) && (iHatchMark < iCloseQuote))
             iEnd = iHatchMark;
            link = page.substring(iURL,iEnd);
            // Trasform in absolute url
							if (link.indexOf("http") == -1) {
								link = domain.concat(link);
							}

							// fix end/problem
							if (! (link.endsWith(".htm") ||link.endsWith(".html")||link.endsWith("/")||link.endsWith(".shtml")||link.endsWith(".php")||link.endsWith(".asp")))
							{
								link=link.concat("/");
				}
             bagOfLinks.addElement( link );

         } } }
    index = iEndAngle;
   }

 */
 /*  while(lastPosition != -1 ) {
		lastPosition = page.indexOf("<a", lastPosition);
        if (lastPosition != -1) {
			lastPosition = page.indexOf("href=\"", lastPosition);

			if (lastPosition != -1) {
				lastPosition=lastPosition+6;
				endOfURL = page.indexOf("\"", lastPosition   );

				// extract found hypertext link
				link = page.substring(lastPosition, endOfURL);
				link = link.trim();
				// ignore refereces
				if (link.indexOf("#") != -1) {
					link = link.substring(0, link.indexOf("#"));
				}
				// ignore commands
							if (link.indexOf("?") != -1) {
								link = link.substring(0, link.indexOf("?"));
				}
				// ignore quotes
						if (link.indexOf("\'") != -1) {
								link = link.substring(0, link.indexOf("\'"));
				}
				// Trasform in absolute url
				if (link.indexOf("http") == -1) {
					link = domain.concat(link);
				}
				//fix ../ problem
				if(link.indexOf("../")!=-1)
				{
				 int i=domain.length()-1;
				 while (domain.indexOf("/",i)>=domain.length()-1)
						{i--;
						}
				String tmp=link.substring(0, i+1);
				link=tmp.concat(link.substring(domain.length()+3,link.length()));
				}
				// fix end/problem
				if (! (link.endsWith(".htm") ||link.endsWith(".html")||link.endsWith("/")||link.endsWith(".shtml")||link.endsWith(".php")||link.endsWith(".asp")))
				{
					link=link.concat("/");
				}
			    // discard strange links
			    if ( (link.indexOf("mailto") != -1) ||
				  link.endsWith(".gif/") ||
				    link.endsWith(".jpg/")||
				    link.endsWith(".gif/"))
			   {;}
		       else {    // collect all others
					bagOfLinks.addElement( link );
					// System.out.println( link );
		        }

				lastPosition++;;     // skip current link
			}
		}
    }*/
    return bagOfLinks;
}
//protected String loadPage(URL page) {
//HTTP http;
//
//    http = new HTTP();
//    return http.downloadWWWPage(page);
//}

protected void markAsVisited(String pageAddr) {
    pageDatabase.put(pageAddr, pageAddr);   // add page to DB
}
protected boolean alreadyVisited(String pageAddr) {
    return pageDatabase.containsKey(pageAddr);
}

public String getPage(URL page)
	{
		String content = new String("");
		int numRead = 0;
		try
		{
			URLConnection conn = page.openConnection();
			conn.setAllowUserInteraction(false);

			InputStream urlStream = page.openStream();
			String type = conn.guessContentTypeFromStream(urlStream);

// 			if (type == null)
// 			{
// 				System.err.println("ERROR: url has no known type: "+url);
// 				return false;
// 			}
// 			if (type.compareTo("text/html") != 0)
// 			{
// 				System.err.println("ERROR: url has no text/html type: "+url);
// 				return false;
// 			}

			// search the input stream for links
			// first, read in the entire URL
			byte b[] = new byte[1000];
			numRead = urlStream.read(b);
			content = new String(b, 0, numRead);

			while (numRead != -1)
			{
				numRead = urlStream.read(b);

				if (numRead != -1)
				{
					String newContent = new String(b, 0, numRead);
					content += newContent;
				}
			}
			urlStream.close();
		}
		catch (Exception e)
		{
			return null;
		}
		catch (OutOfMemoryError e)
		{
			return null;
		}

		return content;

	}

	/*----------------------------------------------------------------------- main()
		|
	\-----------------------------------------------------------------------------*/
    public static void main (String argv[])
	{
		WebCrawler2 crawler = new WebCrawler2();

		crawler.init();
		crawler.crawl("http://www.stratics.com/");



	}

}
