REM ------------------------------------------------------- One url lookup
SELECT EntryId, URL
	FROM Entry
	WHERE url = "http://www.php.net/index.php";
		

REM ------------------------------------------------------- Keyword search		
SELECT URL
	FROM Entry
	WHERE LOWER(Domain) LIKE "%math%"  OR LOWER(Path) LIKE "%math%" 
		OR LOWER(Page) LIKE "%math%";


REM ------------------------------------------------------ Simple Aggregate
SELECT COUNT(*) FROM Entry UNION SELECT COUNT(*) FROM Link

REM ------------------------------------ Group Aggregate, with simple join		
SELECT E.Domain, COUNT(L.Entry) AS Number_of_links
	FROM Entry E, Link L
	WHERE L.Entry = EntryId 
	GROUP BY E.Domain
	HAVING E.Domain = "http://www.php.net";
		

REM -------------------------- group Aggregate with join and keyword search
SELECT U.URL, COUNT(LinksTo) As num_linked_from
	FROM Entry U, Link L
	WHERE EntryId = LinksTo AND (LOWER(U.Domain) LIKE "%math%"  
		OR LOWER(U.Path) LIKE "%math%" 
		OR LOWER(U.Page) LIKE "%math%")
	GROUP BY U.URL
	ORDER BY num_linked_from DESC, U.url
	LIMIT 10;

    